#!/bin/bash
#	ライブラリーを豚に変えてしまう
#
#	[mode-1]
#	fatty_apple.sh dir1 dir2 dir3 libraries,...
#		dir1にあるアーキテクチュアのライブラリが, dir2に別のがいてる．
#		それで豚をdir3に入れる.
#		入れるライブラリーは, libraries,... に指定する
#
#	[mode-2]
#	fatty_apple.sh dir1 dir2
#		dir1は  fswatch_analyze.sh で作成したあるアーキテクチュアのイメージ
#		dir2は  fswatch_analyze.sh で作成したあるアーキテクチュアのイメージ
#		dir1を検索して, バイナリーファイルを発見し,
#		インストール先のファイルが豚でない場合に,
#		dir1, dir2を参照して豚を作成し, dir1を書き換える
TEMP=`mktemp -d`
DIR1=$1
shift
DIR2=$1
shift
DIR3=$1
shift
if	[	"$DIR1"	==	"" -o "$DIR2" == "" -o "$DIR3" == ""	];then
	echo "インストール先書き換えモードが発動しました"
	if [ -f $TEMP/list ];then
		rm	$TEMP/list
	fi
	find $DIR1 -type f -exec file -F , {} \; |while IFS=, read NAME TYPE ETC
	do
		case $TYPE in
		" current ar archive random library")
			echo "${NAME#*/}"	>> $TEMP/list
			;;
		" Mach-O"*)
			echo "${NAME#*/}"	>> $TEMP/list
			;;
		*text|*empty|*script*|*libtool*|*Web*|*image*|*Font*|*OpenType*|*PDF*|*Format*|*JSON*|*data*)
			;;
		*Windows*INF*|*Dyalog*)
			;;
		*)	echo "What is $TYPE $ETC for [$NAME]"
			exit 4;
			;;
		esac
	done
	echo "書き換え対象を特定"
	cat	$TEMP/list|while read line
	do
		STAT=`lipo -info /$line|cut -f1 -d:`
		if [ "$STAT" == "Non-fat file" ];then
			echo -e "/$line を書き換えたいな. \c"
			A1=`lipo -info $DIR1/$line`
			V1="${A1##*:}"
			A2=`lipo -info $DIR2/$line`
			V2="${A2##*:}"
			if [ $V1 != $V2 ];then
				BASEN=`basename $line`
				CMD="lipo -create -arch $V1 $DIR1/$line -arch $V2 $DIR2/$line -output $TEMP/$BASEN"
				eval $CMD
				A3=`lipo -info $TEMP/$BASEN`
				V3="${A3##*:}"
				echo -e "$V3 を作成. \c"
				cp $TEMP/$BASEN $DIR1/$line
				echo "書き換え完了"
			fi
		fi
	done
	echo "${DIR1}を書き換えました"
	exit	0
fi
if	[	!	-d $DIR1	];then
	echo "$DIR1 がフォルダーじゃねえぞ"
	exit	1
fi
if	[	!	-d $DIR2	];then
	echo "$DIR2 がフォルダーじゃねえぞ"
	exit	1
fi
if	[	!	-d $DIR3	];then
	echo "$DIR3 がフォルダーじゃねえぞ"
	exit	1
fi
NC=`ls -l1 $DIR3|wc -l`
if [	$NC	-ne 0	];then
	echo "$DIR3 になんか入ってんぞ"
	ls	-l	$DIR3
	exit	1
fi
do_work(){
	SKIP=0
	if [ ! -f "$DIR1/$file" ];then
		echo "$DIR1/$file がねえぞクソが"
		SKIP=1
	else
		A=`lipo -info $DIR1/$file`
		if [ "${A%%:*}" == "Non-fat file" ];then N1=1;else N1=0;fi
		V1="${A##*:}"
	fi
	if [ ! -f "$DIR2/$file" ];then
		echo "$DIR2/$file がねえぞクソが"
		SKIP=2
	else
		A=`lipo -info $DIR2/$file`
		if [ "${A%%:*}" == "Non-fat file" ];then N2=1;else N2=0;fi
		V2="${A##*:}"
	fi
	if [ $N1 -eq 0 ];then
		echo "$DIR1/$file is fatty, ignored"
		continue
	fi
	if [ $N2 -eq 0 ];then
		echo "$DIR2/$file is fatty, ignored"
		continue
	fi
	DIRN=$(dirname $file)
	BASN=$(basename $file)
	if [ ! -d $DIR3/$DIRN ];then
		mkdir -p "$DIR3/$DIRN"
		if [ $? -ne 0 ];then
			echo "$DIR3/$DIRN がつくれねーよ"
			exit 3
		fi
	fi
	case $SKIP in
	0)
		CMD="lipo -create -arch $V1 $DIR1/$file -arch $V2 $DIR2/$file -output $DIR3/$file"
		eval $CMD
		;;
	1)
		CMD="cp $DIR2/$file $DIR3/$file"
		eval $CMD
		;;
	2)
		CMD="cp $DIR1/$file $DIR3/$file"
		eval $CMD
		;;
	esac
	lipo -info $DIR3/$file
}
if [ $# -ne 0 ];then
	for file in $*
	do
		do_work
	done
else
	while read file
	do
		do_work
	done
fi	
